<?php

/**
 * Kirki Advanced Customizer
 * @package kakina
 */
// Early exit if Kirki is not installed
if ( !class_exists( 'Kirki' ) ) {
	return;
}
/* Register Kirki config */
Kirki::add_config( 'kakina_settings', array(
	'capability'	 => 'edit_theme_options',
	'option_type'	 => 'theme_mod',
) );

/**
 * Add sections
 */
Kirki::add_section( 'sidebar_section', array(
	'title'			 => __( 'Sidebars', 'kakina' ),
	'priority'		 => 10,
	'description'	 => __( 'Sidebar layouts.', 'kakina' ),
) );

Kirki::add_section( 'layout_section', array(
	'title'			 => __( 'Main styling', 'kakina' ),
	'priority'		 => 10,
	'description'	 => __( 'Define theme layout', 'kakina' ),
) );

Kirki::add_section( 'top_bar_section', array(
	'title'			 => __( 'Top Bar', 'kakina' ),
	'priority'		 => 10,
	'description'	 => __( 'Top bar text', 'kakina' ),
) );

Kirki::add_section( 'search_bar_section', array(
	'title'			 => __( 'Search Bar & Social', 'kakina' ),
	'priority'		 => 10,
	'description'	 => __( 'Search and social icons', 'kakina' ),
) );

Kirki::add_section( 'site_bg_section', array(
	'title'		 => __( 'Site Background', 'kakina' ),
	'priority'	 => 10,
) );

if ( class_exists( 'WooCommerce' ) ) {
	Kirki::add_section( 'woo_section', array(
		'title'		 => __( 'WooCommerce', 'kakina' ),
		'priority'	 => 10,
	) );
}
Kirki::add_section( 'links_section', array(
	'title'		 => __( 'Theme Important Links', 'kakina' ),
	'priority'	 => 190,
) );


Kirki::add_field( 'kakina_settings', array(
	'type'			 => 'switch',
	'settings'		 => 'rigth-sidebar-check',
	'label'			 => __( 'Right Sidebar', 'kakina' ),
	'description'	 => __( 'Enable the Right Sidebar', 'kakina' ),
	'section'		 => 'sidebar_section',
	'default'		 => 1,
	'priority'		 => 10,
) );

Kirki::add_field( 'kakina_settings', array(
	'type'		 => 'radio-buttonset',
	'settings'	 => 'right-sidebar-size',
	'label'		 => __( 'Right Sidebar Size', 'kakina' ),
	'section'	 => 'sidebar_section',
	'default'	 => '3',
	'priority'	 => 10,
	'choices'	 => array(
		'1'	 => '1',
		'2'	 => '2',
		'3'	 => '3',
		'4'	 => '4',
	),
) );

Kirki::add_field( 'kakina_settings', array(
	'type'			 => 'switch',
	'settings'		 => 'left-sidebar-check',
	'label'			 => __( 'Left Sidebar', 'kakina' ),
	'description'	 => __( 'Enable the Left Sidebar', 'kakina' ),
	'section'		 => 'sidebar_section',
	'default'		 => 0,
	'priority'		 => 10,
) );

Kirki::add_field( 'kakina_settings', array(
	'type'		 => 'radio-buttonset',
	'settings'	 => 'left-sidebar-size',
	'label'		 => __( 'Left Sidebar Size', 'kakina' ),
	'section'	 => 'sidebar_section',
	'default'	 => '3',
	'priority'	 => 10,
	'choices'	 => array(
		'1'	 => '1',
		'2'	 => '2',
		'3'	 => '3',
		'4'	 => '4',
	),
) );


Kirki::add_field( 'kakina_settings', array(
	'type'			 => 'image',
	'settings'		 => 'header-logo',
	'label'			 => __( 'Logo', 'kakina' ),
	'description'	 => __( 'Upload your logo', 'kakina' ),
	'section'		 => 'layout_section',
	'default'		 => '',
	'priority'		 => 10,
) );


Kirki::add_field( 'kakina_settings', array(
	'type'				 => 'textarea',
	'settings'			 => 'infobox-text-left',
	'label'				 => __( 'Top bar left', 'kakina' ),
	'description'		 => __( 'Top bar left text area', 'kakina' ),
	'help'				 => __( 'You can add custom text. Only text allowed!', 'kakina' ),
	'section'			 => 'top_bar_section',
	'sanitize_callback'	 => 'wp_kses_post',
	'default'			 => '',
	'priority'			 => 10,
) );
Kirki::add_field( 'kakina_settings', array(
	'type'				 => 'textarea',
	'settings'			 => 'infobox-text-center',
	'label'				 => __( 'Top bar center', 'kakina' ),
	'description'		 => __( 'Top bar center text area', 'kakina' ),
	'help'				 => __( 'You can add custom text. Only text allowed!', 'kakina' ),
	'section'			 => 'top_bar_section',
	'sanitize_callback'	 => 'wp_kses_post',
	'default'			 => '',
	'priority'			 => 10,
) );

Kirki::add_field( 'kakina_settings', array(
	'type'			 => 'switch',
	'settings'		 => 'search-bar-check',
	'label'			 => __( 'Search bar', 'kakina' ),
	'description'	 => __( 'Enable search bar with social icons', 'kakina' ),
	'section'		 => 'search_bar_section',
	'default'		 => 1,
	'priority'		 => 10,
) );
Kirki::add_field( 'kakina_settings', array(
	'type'		 => 'select',
	'settings'	 => 'shop-by-cat-menu',
	'label'		 => __( 'Shop By Category Menu', 'kakina' ),
	'section'	 => 'search_bar_section',
	'default'	 => '',
	'priority'	 => 10,
	'choices'	 => kakina_menu_list(),
	'required'	 => array(
		array(
			'setting'	 => 'search-bar-check',
			'operator'	 => '==',
			'value'		 => 1,
		),
	)
) );
Kirki::add_field( 'kakina_settings', array(
	'type'			 => 'switch',
	'settings'		 => 'kakina_socials',
	'label'			 => __( 'Social Icons', 'kakina' ),
	'description'	 => __( 'Enable or Disable the social icons', 'kakina' ),
	'section'		 => 'search_bar_section',
	'default'		 => 0,
	'priority'		 => 10,
	'required'		 => array(
		array(
			'setting'	 => 'search-bar-check',
			'operator'	 => '==',
			'value'		 => 1,
		),
	)
) );
Kirki::add_field( 'kakina_settings', array(
	'type'			 => 'text',
	'settings'		 => 'kakina_socials_text',
	'label'			 => __( 'Follow Us Text', 'kakina' ),
	'description'	 => __( 'Insert your text before social icons.', 'kakina' ),
	'help'			 => __( 'Leave blank to hide text.', 'kakina' ),
	'section'		 => 'search_bar_section',
	'default'		 => 'Follow Us',
	'priority'		 => 10,
	'required'		 => array(
		array(
			'setting'	 => 'kakina_socials',
			'operator'	 => '==',
			'value'		 => 1,
		),
	)
) );
$s_social_links = array(
	'twp_social_facebook'	 => __( 'Facebook', 'kakina' ),
	'twp_social_twitter'	 => __( 'Twitter', 'kakina' ),
	'twp_social_google'		 => __( 'Google-Plus', 'kakina' ),
	'twp_social_instagram'	 => __( 'Instagram', 'kakina' ),
	'twp_social_pin'		 => __( 'Pinterest', 'kakina' ),
	'twp_social_youtube'	 => __( 'YouTube', 'kakina' ),
	'twp_social_reddit'		 => __( 'Reddit', 'kakina' ),
);

foreach ( $s_social_links as $keys => $values ) {
	Kirki::add_field( 'kakina_settings', array(
		'type'			 => 'text',
		'settings'		 => $keys,
		'label'			 => $values,
		'description'	 => sprintf( __( 'Insert your custom link to show the %s icon.', 'kakina' ), $values ),
		'help'			 => __( 'Leave blank to hide icon.', 'kakina' ),
		'section'		 => 'search_bar_section',
		'default'		 => '',
		'priority'		 => 10,
		'required'		 => array(
			array(
				'setting'	 => 'search-bar-check',
				'operator'	 => '==',
				'value'		 => 1,
			),
		)
	) );
}

if ( function_exists( 'YITH_WCWL' ) ) {
	Kirki::add_field( 'kakina_settings', array(
		'type'			 => 'switch',
		'settings'		 => 'wishlist-top-icon',
		'label'			 => __( 'Header Wishlist icon', 'kakina' ),
		'description'	 => __( 'Enable or disable heart icon with counter in header', 'kakina' ),
		'section'		 => 'woo_section',
		'default'		 => 0,
		'priority'		 => 10,
	) );
}
Kirki::add_field( 'kakina_settings', array(
	'type'			 => 'slider',
	'settings'		 => 'archive_number_products',
	'label'			 => __( 'Number of products', 'kakina' ),
	'description'	 => __( 'Change number of products displayed per page in archive(shop) page.', 'kakina' ),
	'section'		 => 'woo_section',
	'default'		 => 24,
	'priority'		 => 10,
	'choices'		 => array(
		'min'	 => 2,
		'max'	 => 60,
		'step'	 => 1
	),
) );
Kirki::add_field( 'kakina_settings', array(
	'type'			 => 'slider',
	'settings'		 => 'archive_number_columns',
	'label'			 => __( 'Number of products per row', 'kakina' ),
	'description'	 => __( 'Change the number of product columns per row in archive(shop) page.', 'kakina' ),
	'section'		 => 'woo_section',
	'default'		 => 4,
	'priority'		 => 10,
	'choices'		 => array(
		'min'	 => 2,
		'max'	 => 5,
		'step'	 => 1
	),
) );

Kirki::add_field( 'kakina_settings', array(
	'type'		 => 'background',
	'settings'	 => 'background_site',
	'label'		 => __( 'Background', 'kakina' ),
	'section'	 => 'site_bg_section',
	'default'	 => array(
		'color'		 => '#fff',
		'image'		 => '',
		'repeat'	 => 'no-repeat',
		'size'		 => 'cover',
		'attach'	 => 'fixed',
		'position'	 => 'center-top',
		'opacity'	 => 100,
	),
	'priority'	 => 10,
	'output'	 => 'body',
) );
$theme_links = array(
	'documentation'	 => array(
		'link'		 => esc_url( 'http://demo.themes4wp.com/documentation/category/kakina/' ),
		'text'		 => __( 'Documentation', 'kakina' ),
		'settings'	 => 'theme-docs',
	),
	'support'		 => array(
		'link'		 => esc_url( 'http://support.themes4wp.com/' ),
		'text'		 => __( 'Support', 'kakina' ),
		'settings'	 => 'theme-support',
	),
	'demo'			 => array(
		'link'		 => esc_url( 'http://demo.themes4wp.com/kakina/' ),
		'text'		 => __( 'View Demo', 'kakina' ),
		'settings'	 => 'theme-demo',
	),
	'rating'		 => array(
		'link'		 => esc_url( 'https://wordpress.org/support/view/theme-reviews/kakina?filter=5' ),
		'text'		 => __( 'Rate This Theme', 'kakina' ),
		'settings'	 => 'theme-rate',
	)
);

foreach ( $theme_links as $theme_link ) {
	Kirki::add_field( 'blogr_settings', array(
		'type'		 => 'custom',
		'settings'	 => $theme_link[ 'settings' ],
		'section'	 => 'links_section',
		'default'	 => '<div style="padding: 10px; text-align: center; font-size: 20px; font-weight: bold;"><a target="_blank" href="' . $theme_link[ 'link' ] . '" >' . esc_attr( $theme_link[ 'text' ] ) . ' </a></div>',
		'priority'	 => 10,
	) );
}

function kakina_configuration() {

	$config[ 'logo_image' ]	 = get_template_directory_uri() . '/img/site-logo.png';
	$config[ 'color_back' ]	 = '#192429';
	$config[ 'color_accent' ]	 = '#008ec2';
	$config[ 'width' ]		 = '25%';

	return $config;
}

add_filter( 'kirki/config', 'kakina_configuration' );

function kakina_configuration_i18n( $config ) {

	$strings = array(
		'background-color'		 => __( 'Background Color', 'kakina' ),
		'background-image'		 => __( 'Background Image', 'kakina' ),
		'no-repeat'				 => __( 'No Repeat', 'kakina' ),
		'repeat-all'			 => __( 'Repeat All', 'kakina' ),
		'repeat-x'				 => __( 'Repeat Horizontally', 'kakina' ),
		'repeat-y'				 => __( 'Repeat Vertically', 'kakina' ),
		'inherit'				 => __( 'Inherit', 'kakina' ),
		'background-repeat'		 => __( 'Background Repeat', 'kakina' ),
		'cover'					 => __( 'Cover', 'kakina' ),
		'contain'				 => __( 'Contain', 'kakina' ),
		'background-size'		 => __( 'Background Size', 'kakina' ),
		'fixed'					 => __( 'Fixed', 'kakina' ),
		'scroll'				 => __( 'Scroll', 'kakina' ),
		'background-attachment'	 => __( 'Background Attachment', 'kakina' ),
		'left-top'				 => __( 'Left Top', 'kakina' ),
		'left-center'			 => __( 'Left Center', 'kakina' ),
		'left-bottom'			 => __( 'Left Bottom', 'kakina' ),
		'right-top'				 => __( 'Right Top', 'kakina' ),
		'right-center'			 => __( 'Right Center', 'kakina' ),
		'right-bottom'			 => __( 'Right Bottom', 'kakina' ),
		'center-top'			 => __( 'Center Top', 'kakina' ),
		'center-center'			 => __( 'Center Center', 'kakina' ),
		'center-bottom'			 => __( 'Center Bottom', 'kakina' ),
		'background-position'	 => __( 'Background Position', 'kakina' ),
		'background-opacity'	 => __( 'Background Opacity', 'kakina' ),
		'ON'					 => __( 'ON', 'kakina' ),
		'OFF'					 => __( 'OFF', 'kakina' ),
		'all'					 => __( 'All', 'kakina' ),
		'cyrillic'				 => __( 'Cyrillic', 'kakina' ),
		'cyrillic-ext'			 => __( 'Cyrillic Extended', 'kakina' ),
		'devanagari'			 => __( 'Devanagari', 'kakina' ),
		'greek'					 => __( 'Greek', 'kakina' ),
		'greek-ext'				 => __( 'Greek Extended', 'kakina' ),
		'khmer'					 => __( 'Khmer', 'kakina' ),
		'latin'					 => __( 'Latin', 'kakina' ),
		'latin-ext'				 => __( 'Latin Extended', 'kakina' ),
		'vietnamese'			 => __( 'Vietnamese', 'kakina' ),
		'serif'					 => _x( 'Serif', 'font style', 'kakina' ),
		'sans-serif'			 => _x( 'Sans Serif', 'font style', 'kakina' ),
		'monospace'				 => _x( 'Monospace', 'font style', 'kakina' ),
	);

	$config[ 'i18n' ] = $strings;

	return $config;
}

add_filter( 'kirki/config', 'kakina_configuration_i18n' );

/**
 * Add custom CSS styles
 */
function kakina_enqueue_header_css() {

	$columns = get_theme_mod( 'archive_number_columns', 4 );

	if ( $columns == '2' ) {
		$css = '@media only screen and (min-width: 769px) {.archive .rsrc-content .woocommerce ul.products li.product{width: 48.05%}}';
	} elseif ( $columns == '3' ) {
		$css = '@media only screen and (min-width: 769px) {.archive .rsrc-content .woocommerce ul.products li.product{width: 30.75%;}}';
	} elseif ( $columns == '5' ) {
		$css = '@media only screen and (min-width: 769px) {.archive .rsrc-content .woocommerce ul.products li.product{width: 16.95%;}}';
	} else {
		$css = '';
	}
	wp_add_inline_style( 'kirki-styles-kakina_settings', $css );
}

add_action( 'wp_enqueue_scripts', 'kakina_enqueue_header_css', 9999 );

function kakina_menu_list() {
	$menus			 = array();
	$menus[ 0 ]		 = __( 'Select Menu', 'kakina' );
	$menus_select	 = get_terms( 'nav_menu', array( 'hide_empty' => true ) );
	foreach ( $menus_select as $menu ) {
		$menus[ $menu->term_id ] = $menu->name;
	}
	return $menus;
}
